{
    "$graph": [
        {
            "class": "CommandLineTool",
            "requirements": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "alpine"
                },
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "ShellCommandRequirement"
                }
            ],
            "inputs": [
                {
                    "id": "#unix_align_cmd.cwl/fastq1_path",
                    "type": "File"
                },
                {
                    "id": "#unix_align_cmd.cwl/fastq2_path",
                    "type": "File"
                },
                {
                    "id": "#unix_align_cmd.cwl/readgroup_path",
                    "type": "File"
                }
            ],
            "arguments": [
                {
                    "valueFrom": "$(  '\"' + inputs.fastq1_path.path.split('/').slice(-1)[0] + '\"' )",
                    "position": 1,
                    "shellQuote": false
                },
                {
                    "valueFrom": ">",
                    "position": 2,
                    "shellQuote": false
                },
                {
                    "valueFrom": "$( inputs.readgroup_path.path.split('/').slice(-1)[0].slice(0,-10)+\"_realign.bam\" )",
                    "position": 3,
                    "shellQuote": false
                },
                {
                    "valueFrom": "&&",
                    "position": 4,
                    "shellQuote": false
                },
                {
                    "valueFrom": "echo",
                    "position": 5,
                    "shellQuote": false
                },
                {
                    "valueFrom": "$(  '\"' + inputs.fastq2_path.path.split('/').slice(-1)[0] + '\"' )",
                    "position": 6,
                    "shellQuote": false
                },
                {
                    "valueFrom": ">>",
                    "position": 7,
                    "shellQuote": false
                },
                {
                    "valueFrom": "$( inputs.readgroup_path.path.split('/').slice(-1)[0].slice(0,-10)+\"_realign.bam\" )",
                    "position": 8,
                    "shellQuote": false
                },
                {
                    "valueFrom": "&&",
                    "position": 9,
                    "shellQuote": false
                },
                {
                    "valueFrom": "echo",
                    "position": 10,
                    "shellQuote": false
                },
                {
                    "valueFrom": "$(  '\"' + inputs.readgroup_path.path.split('/').slice(-1)[0] + '\"' )",
                    "position": 11,
                    "shellQuote": false
                },
                {
                    "valueFrom": ">>",
                    "position": 12,
                    "shellQuote": false
                },
                {
                    "valueFrom": "$( inputs.readgroup_path.path.split('/').slice(-1)[0].slice(0,-10)+\"_realign.bam\" )",
                    "position": 13,
                    "shellQuote": false
                }
            ],
            "baseCommand": "echo",
            "id": "#unix_align_cmd.cwl",
            "outputs": [
                {
                    "id": "#unix_align_cmd.cwl/output_bam",
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(  inputs.readgroup_path.path.split('/').slice(-1)[0].slice(0,-10)+\"_realign.bam\" )"
                    }
                }
            ]
        },
        {
            "class": "CommandLineTool",
            "requirements": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "alpine"
                },
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "ShellCommandRequirement"
                }
            ],
            "inputs": [
                {
                    "id": "#unix_bamreadgroup_cmd.cwl/bam_path",
                    "type": "File",
                    "inputBinding": {
                        "position": 2
                    }
                }
            ],
            "outputs": [
                {
                    "id": "#unix_bamreadgroup_cmd.cwl/output_readgroup",
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputBinding": {
                        "glob": "*.readgroup",
                        "outputEval": "$( self.sort(function(a,b) { return a.location > b.location }) )"
                    }
                }
            ],
            "arguments": [
                {
                    "valueFrom": ".readgroup",
                    "position": 1,
                    "shellQuote": false
                },
                {
                    "valueFrom": "|",
                    "position": 3,
                    "shellQuote": false
                },
                {
                    "valueFrom": "xargs",
                    "position": 4,
                    "shellQuote": false
                },
                {
                    "valueFrom": "touch",
                    "position": 5,
                    "shellQuote": false
                }
            ],
            "baseCommand": "grep",
            "id": "#unix_bamreadgroup_cmd.cwl"
        },
        {
            "class": "CommandLineTool",
            "requirements": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "alpine"
                },
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "ShellCommandRequirement"
                }
            ],
            "inputs": [
                {
                    "id": "#unix_bamtofastq_cmd.cwl/bam_path",
                    "type": "File",
                    "inputBinding": {
                        "position": 2
                    }
                }
            ],
            "outputs": [
                {
                    "id": "#unix_bamtofastq_cmd.cwl/output_fastq1",
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputBinding": {
                        "glob": "*_1.fq",
                        "outputEval": "$( self.sort(function(a,b) { return a.location > b.location }) )"
                    }
                },
                {
                    "id": "#unix_bamtofastq_cmd.cwl/output_fastq2",
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputBinding": {
                        "glob": "*_2.fq",
                        "outputEval": "$( self.sort(function(a,b) { return a.location > b.location }) )"
                    }
                }
            ],
            "arguments": [
                {
                    "valueFrom": ".fq",
                    "position": 1,
                    "shellQuote": false
                },
                {
                    "valueFrom": "|",
                    "position": 4,
                    "shellQuote": false
                },
                {
                    "valueFrom": "xargs",
                    "position": 5,
                    "shellQuote": false
                },
                {
                    "valueFrom": "touch",
                    "position": 6,
                    "shellQuote": false
                }
            ],
            "baseCommand": "grep",
            "id": "#unix_bamtofastq_cmd.cwl"
        },
        {
            "class": "CommandLineTool",
            "requirements": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "ubuntu"
                },
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "ShellCommandRequirement"
                }
            ],
            "inputs": [
                {
                    "id": "#unix_merge_cmd.cwl/INPUT",
                    "type": {
                        "type": "array",
                        "items": "File"
                    }
                },
                {
                    "id": "#unix_merge_cmd.cwl/OUTPUT",
                    "type": "string"
                }
            ],
            "outputs": [
                {
                    "id": "#unix_merge_cmd.cwl/MERGED_OUTPUT",
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.OUTPUT)"
                    }
                }
            ],
            "arguments": [
                {
                    "valueFrom": "${\n  var cmd = \"\";\n  for (var i = 0; i < inputs.INPUT.length; i++) {\n    if (i == inputs.INPUT.length - 1) {\n      cmd += \"cat \" + inputs.INPUT[i].path + \" >> \" + inputs.OUTPUT;\n    }\n    else {\n      cmd += \"cat \" + inputs.INPUT[i].path + \" >> \" + inputs.OUTPUT + \" && \";\n    }\n  }\n  return cmd\n}\n"
                }
            ],
            "baseCommand": [
                "bash",
                "-c"
            ],
            "id": "#unix_merge_cmd.cwl"
        },
        {
            "class": "Workflow",
            "requirements": [
                {
                    "class": "ScatterFeatureRequirement"
                },
                {
                    "class": "StepInputExpressionRequirement"
                },
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "inputs": [
                {
                    "id": "#main/bam_path",
                    "type": "File"
                }
            ],
            "outputs": [
                {
                    "id": "#main/merged_bam",
                    "type": "File",
                    "outputSource": "#main/merge/MERGED_OUTPUT"
                }
            ],
            "steps": [
                {
                    "id": "#main/bamtoreadgroup",
                    "run": "#unix_bamreadgroup_cmd.cwl",
                    "in": [
                        {
                            "id": "#main/bamtoreadgroup/bam_path",
                            "source": "#main/bam_path"
                        }
                    ],
                    "out": [
                        {
                            "id": "#main/bamtoreadgroup/output_readgroup"
                        }
                    ]
                },
                {
                    "id": "#main/bamtofastq",
                    "run": "#unix_bamtofastq_cmd.cwl",
                    "in": [
                        {
                            "id": "#main/bamtofastq/bam_path",
                            "source": "#main/bam_path"
                        }
                    ],
                    "out": [
                        {
                            "id": "#main/bamtofastq/output_fastq1"
                        },
                        {
                            "id": "#main/bamtofastq/output_fastq2"
                        }
                    ]
                },
                {
                    "id": "#main/align",
                    "run": "#unix_align_cmd.cwl",
                    "scatter": [
                        "#main/align/fastq1_path",
                        "#main/align/fastq2_path",
                        "#main/align/readgroup_path"
                    ],
                    "scatterMethod": "dotproduct",
                    "in": [
                        {
                            "id": "#main/align/fastq1_path",
                            "source": "#main/bamtofastq/output_fastq1"
                        },
                        {
                            "id": "#main/align/fastq2_path",
                            "source": "#main/bamtofastq/output_fastq2"
                        },
                        {
                            "id": "#main/align/readgroup_path",
                            "source": "#main/bamtoreadgroup/output_readgroup"
                        }
                    ],
                    "out": [
                        {
                            "id": "#main/align/output_bam"
                        }
                    ]
                },
                {
                    "id": "#main/merge",
                    "run": "#unix_merge_cmd.cwl",
                    "in": [
                        {
                            "id": "#main/merge/INPUT",
                            "source": "#main/align/output_bam"
                        },
                        {
                            "id": "#main/merge/OUTPUT",
                            "source": "#main/bam_path",
                            "valueFrom": "$(self.basename)"
                        }
                    ],
                    "out": [
                        {
                            "id": "#main/merge/MERGED_OUTPUT"
                        }
                    ]
                }
            ],
            "id": "#main"
        }
    ],
    "cwlVersion": "v1.0"
}
